package com.solvians.test;

import javax.annotation.Priority;
import javax.decorator.Decorator;
import javax.decorator.Delegate;
import javax.enterprise.inject.Any;
import javax.inject.Inject;
import javax.interceptor.Interceptor;

/**
 *
 * @author chschroe
 */
@Decorator
@Priority(Interceptor.Priority.APPLICATION)
public abstract class TestDecorator implements TestInterface {

    private final TestInterface delegate;
    
    @Inject
    public TestDecorator(@Delegate @Any TestInterface delegate) {
        this.delegate = delegate;
    }

    @Override
    public void testMethod00001() {
        System.out.println("Decorator has been called!");
        delegate.testMethod00001();
    }
    
}
